# Class JspWriterImpl

java.lang.Object
java.io.Writer
javax.servlet.jsp.JspWriter
org.apache.jasper.runtime.JspWriterImpl

All Implemented Interfaces:
  `Closeable, Flushable, Appendable, AutoCloseable`

public class JspWriterImpl extends JspWriter
Write text to a character-output stream, buffering characters to provide efficient writing of single characters, arrays, and strings. Provide support for discarding the output that has been buffered. This needs revisiting when the buffering problems in the JSP spec are fixed -akv.

## Field Summary

### Fields inherited from class JspWriter

`autoFlush, bufferSize, DEFAULT_BUFFER, NO_BUFFER, UNBOUNDED_BUFFER`

### Fields inherited from class Writer

`lock`

## Constructor Summary

Constructors
Constructor
Description
`JspWriterImpl()`
`JspWriterImpl(ServletResponse response, int sz, boolean autoFlush)`
Create a new buffered character-output stream that uses an output buffer of the given size.

## Method Summary

Modifier and Type
Method
Description
`final void`
`clear()`
Clear the contents of the buffer.
`void`
`clearBuffer()`
Clears the current contents of the buffer.
`void`
`close()`
Close the stream, flushing it first.
`void`
`flush()`
Flush the stream.
`protected final void`
`flushBuffer()`
Flush the output buffer to the underlying character stream, without flushing the stream itself.
`int`
`getRemaining()`
This method returns the number of unused bytes in the buffer.
`void`
`newLine()`
Write a line separator.
`void`
`print(boolean b)`
Print a boolean value.
`void`
`print(char c)`
Print a character.
`void`
`print(char[] s)`
Print an array of characters.
`void`
`print(double d)`
Print a double-precision floating-point number.
`void`
`print(float f)`
Print a floating-point number.
`void`
`print(int i)`
Print an integer.
`void`
`print(long l)`
Print a long integer.
`void`
`print(Object obj)`
Print an object.
`void`
`print(String s)`
Print a string.
`void`
`println()`
Terminate the current line by writing the line separator string.
`void`
`println(boolean x)`
Print a boolean value and then terminate the line.
`void`
`println(char x)`
Print a character and then terminate the line.
`void`
`println(char[] x)`
Print an array of characters and then terminate the line.
`void`
`println(double x)`
Print a double-precision floating-point number and then terminate the line.
`void`
`println(float x)`
Print a floating-point number and then terminate the line.
`void`
`println(int x)`
Print an integer and then terminate the line.
`void`
`println(long x)`
Print a long integer and then terminate the line.
`void`
`println(Object x)`
Print an Object and then terminate the line.
`void`
`println(String x)`
Print a String and then terminate the line.
`void`
`write(char[] buf)`
`void`
`write(char[] cbuf, int off, int len)`
`void`
`write(int c)`
`void`
`write(String s, int off, int len)`

### Methods inherited from class JspWriter

`getBufferSize, isAutoFlush`

### Methods inherited from class Writer

`append, append, append, nullWriter, write`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### JspWriterImpl

public JspWriterImpl()

### JspWriterImpl

public JspWriterImpl(ServletResponse response, int sz, boolean autoFlush)
Create a new buffered character-output stream that uses an output buffer of the given size.

Parameters:
  `response` - A Servlet Response
  `sz` - Output-buffer size, a positive integer
  `autoFlush` - `true` to automatically flush on buffer full, `false` to throw an overflow exception in that case
Throws:
  `IllegalArgumentException` - If sz is <= 0

## Method Details

### flushBuffer

protected final void flushBuffer() throws IOException
Flush the output buffer to the underlying character stream, without flushing the stream itself. This method is non-private only so that it may be invoked by PrintStream.

Throws:
  `IOException` - Error writing buffered data

### clear

public final void clear() throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Clear the contents of the buffer. If the buffer has been already been flushed then the clear operation shall throw an IOException to signal the fact that some data has already been irrevocably written to the client response stream.

Specified by:
  `clear` in class `JspWriter`
Throws:
  `IOException` - If an I/O error occurs

### clearBuffer

public void clearBuffer() throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Clears the current contents of the buffer. Unlike clear(), this method will not throw an IOException if the buffer has already been flushed. It merely clears the current content of the buffer and returns.

Specified by:
  `clearBuffer` in class `JspWriter`
Throws:
  `IOException` - If an I/O error occurs

### flush

public void flush() throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Flush the stream. If the stream has saved any characters from the various write() methods in a buffer, write them immediately to their intended destination. Then, if that destination is another character or byte stream, flush it. Thus one flush() invocation will flush all the buffers in a chain of Writers and OutputStreams.

The method may be invoked indirectly if the buffer size is exceeded.

Once a stream has been closed, further write() or flush() invocations will cause an IOException to be thrown.

Specified by:
  `flush` in interface `Flushable`
Specified by:
  `flush` in class `JspWriter`
Throws:
  `IOException` - If an I/O error occurs

### close

public void close() throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Close the stream, flushing it first.

This method needs not be invoked explicitly for the initial JspWriter as the code generated by the JSP container will automatically include a call to close().

Closing a previously-closed stream, unlike flush(), has no effect.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in class `JspWriter`
Throws:
  `IOException` - If an I/O error occurs

### getRemaining

public int getRemaining()
Description copied from class: `javax.servlet.jsp.JspWriter`
This method returns the number of unused bytes in the buffer.

Specified by:
  `getRemaining` in class `JspWriter`
Returns:
  the number of bytes unused in the buffer

### write

public void write(int c) throws IOException

Overrides:
  `write` in class `Writer`
Throws:
  `IOException`

### write

public void write(char[] cbuf, int off, int len) throws IOException

Specified by:
  `write` in class `Writer`
Throws:
  `IOException`

### write

public void write(char[] buf) throws IOException

Overrides:
  `write` in class `Writer`
Throws:
  `IOException`

### write

public void write(String s, int off, int len) throws IOException

Overrides:
  `write` in class `Writer`
Throws:
  `IOException`

### newLine

public void newLine() throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Write a line separator. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline ('\n') character.

Specified by:
  `newLine` in class `JspWriter`
Throws:
  `IOException` - If an I/O error occurs

### print

public void print(boolean b) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a boolean value. The string produced by ``String.valueOf(boolean)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `b` - The `boolean` to be printed
Throws:
  `IOException` - If an error occurred while writing

### print

public void print(char c) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a character. The character is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `c` - The `char` to be printed
Throws:
  `IOException` - If an error occurred while writing

### print

public void print(int i) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print an integer. The string produced by ``String.valueOf(int)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `i` - The `int` to be printed
Throws:
  `IOException` - If an error occurred while writing
See Also:
  - `Integer.toString(int)`

### print

public void print(long l) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a long integer. The string produced by ``String.valueOf(long)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `l` - The `long` to be printed
Throws:
  `IOException` - If an error occurred while writing
See Also:
  - `Long.toString(long)`

### print

public void print(float f) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a floating-point number. The string produced by ``String.valueOf(float)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `f` - The `float` to be printed
Throws:
  `IOException` - If an error occurred while writing
See Also:
  - `Float.toString(float)`

### print

public void print(double d) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a double-precision floating-point number. The string produced by ``String.valueOf(double)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `d` - The `double` to be printed
Throws:
  `IOException` - If an error occurred while writing
See Also:
  - `Double.toString(double)`

### print

public void print(char[] s) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print an array of characters. The characters are written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `s` - The array of chars to be printed
Throws:
  `IOException` - If an error occurred while writing

### print

public void print(String s) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a string. If the argument is `null` then the string `"null"` is printed. Otherwise, the string's characters are written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `s` - The `String` to be printed
Throws:
  `IOException` - If an error occurred while writing

### print

public void print(Object obj) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print an object. The string produced by the ``String.valueOf(Object)`` method is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.

Specified by:
  `print` in class `JspWriter`
Parameters:
  `obj` - The `Object` to be printed
Throws:
  `IOException` - If an error occurred while writing
See Also:
  - `Object.toString()`

### println

public void println() throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Terminate the current line by writing the line separator string. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline character (`'\n'`).

Specified by:
  `println` in class `JspWriter`
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(boolean x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a boolean value and then terminate the line. This method behaves as though it invokes ``JspWriter.print(boolean)`` and then ``JspWriter.println()``.

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the boolean to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(char x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a character and then terminate the line. This method behaves as though it invokes ``JspWriter.print(char)`` and then ``JspWriter.println()`` .

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the char to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(int x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print an integer and then terminate the line. This method behaves as though it invokes ``JspWriter.print(int)`` and then ``JspWriter.println()`` .

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the int to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(long x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a long integer and then terminate the line. This method behaves as though it invokes ``JspWriter.print(long)`` and then ``JspWriter.println()``.

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the long to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(float x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a floating-point number and then terminate the line. This method behaves as though it invokes ``JspWriter.print(float)`` and then ``JspWriter.println()``.

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the float to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(double x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a double-precision floating-point number and then terminate the line. This method behaves as though it invokes ``JspWriter.print(double)`` and then ``JspWriter.println()``.

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the double to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(char[] x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print an array of characters and then terminate the line. This method behaves as though it invokes `print(char[])` and then `println()`.

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the char[] to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(String x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print a String and then terminate the line. This method behaves as though it invokes ``JspWriter.print(String)`` and then ``JspWriter.println()``.

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the String to write
Throws:
  `IOException` - If an error occurred while writing

### println

public void println(Object x) throws IOException
Description copied from class: `javax.servlet.jsp.JspWriter`
Print an Object and then terminate the line. This method behaves as though it invokes ``JspWriter.print(Object)`` and then ``JspWriter.println()``.

Specified by:
  `println` in class `JspWriter`
Parameters:
  `x` - the Object to write
Throws:
  `IOException` - If an error occurred while writing